/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DCANVASITEMBASE_H
#define _DCANVASITEMBASE_H

#include <qcanvas.h>
#include "../gui/DGuiItem.h"
#include "../datastruct/DItem.h"

class DDataItemBase;
class QPoint;
class QPainter;
class DCanvasView;
class DCanvasLink;
class DCanvasPos;
class DCanvasItemBase : public QCanvasRectangle, public DGuiItem
{
	public:
		DCanvasItemBase(QWidget *, int id);
		virtual ~DCanvasItemBase();	

		void setOffset(const QPoint &);
		virtual void mouseReleaseEvent(QMouseEvent *me);
		virtual void mouseMoveEvent(QMouseEvent *me);
		
		bool onWidget(const QPoint & p);
		bool displayChildIdx() const;
		
		void setDisplayIdx(bool);
		void setSelected(bool b = true);

		void setSize( int , int );

		void move(double, double);
		virtual void updatePos();
		void updateLink();
		void loadPos();

		int numChild();

	private:
		QPoint m_pressOffset;
		QPoint m_old;

		QColor m_color;

		bool moving;

		DCanvasView* m_canvasview;
		DCanvasLink* m_link;
		DCanvasPos* m_pos;
		bool m_displaychildidx;

		
	protected:
		//DDataItemBase* data();
		
		virtual void drawShape(QPainter &p);
		virtual void drawSelected(QPainter& p);
		virtual void drawContent(QPainter& p);
	
		QPixmap m_displayedpix;
		//int m_pressXOffset, m_pressYOffset;
		//int m_oldX, m_oldY;
};


#endif // _DCANVASITEMBASE_H

