/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qfontmetrics.h>
#include <qstring.h>
#include <qpainter.h>
#include "DCanvasPos.h"
#include "DCanvasItemBase.h"

DCanvasPos::DCanvasPos(QCanvas* canvas, DCanvasItemBase* parent) : QCanvasEllipse(canvas)
{
	m_parent = parent;
	QCanvasEllipse::setBrush( QColor(Qt::yellow) );
	setSize( RAY, RAY );
}

DCanvasPos::~DCanvasPos()
{

}

void DCanvasPos::drawShape(QPainter &p)
{
	QCanvasEllipse::drawShape(p);

	// +1 is to avoid displaying "0"
	QString text = QString::number(m_parent->numChild()+1);
	
	p.setPen( QColor(Qt::black) );
	
	QFont font = QFont("times", 10, QFont::Normal);
	p.setFont(font);

	QFontMetrics fm = QFontMetrics( font );
	int twidth = fm.width(text);
	int theight = fm.height();
	
	// FIXME
	p.drawText(x()-twidth/2, y()+theight/4, text );
}

int DCanvasPos::Id()
{
	return m_parent->Id();
}

void DCanvasPos::updatePos()
{
	update();
}
