/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DDATAITEMBASE_H
#define _DDATAITEMBASE_H

#include <qfont.h>
#include <qvaluelist.h>
#include "DItem.h"

class QPixmap;
class QString;
class QColor;
class QTextStream;
class QFont;
class DDataItemBase : public DItem
{
	public:
		DDataItemBase(int);
		~DDataItemBase();

		void addChild( int );
		void setParent( int );
		void removeChild( int );


		// number of children
		int countChildren() const;

		// id of the nth child
		int childNum(int) const;

		// index of a child (using its id)
		int childIdx(int) const;

		// reorganize a child
		void setChildIdx( int, int );


		
		// id of the parent
		int Parent();

		// make an orphan ..
		void setNoParent();

		// print
		void printSelf(QTextStream&);
		virtual void printData(QTextStream&);
		void initColor();
		
		// position of items on canvas
		void setXY(int, int);

		QColor m_framecolor;
		QColor m_conncolor;
		
		QColor m_fillcolor;
		QColor m_outlinecolor;
		QColor m_textcolor;

		QFont m_defaultFont;


		int x() const { return m_x; }
		int y() const { return m_y; }

	private:
		QValueList<int> m_children;

		int m_x;
		int m_y;

	protected:
		int m_parent;

	public:
		static QString protectXML(const QString & str);
		static QString printXMLTag(const QString & tag, const QString & str, int padding = 0);


};

#endif // _DDATAITEMBASE_H

