/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qcolor.h>
#include <qpixmap.h>
#include <qstringlist.h>
#include <qstring.h>
#include <qimage.h>
#include <qbitarray.h>
#include <qbuffer.h>

#include <kdebug.h>
#include <kstandarddirs.h>
#include <kiconloader.h>
#include <kurl.h>
#include <klocale.h>

#include "../gui/settings.h"
#include "DDataItemPix.h"

DDataItemPix::DDataItemPix(int i) : DDataItemBase(i)
{
	m_type = DItem::Pix;
	m_legend = i18n("Change this picture and set a caption");
	
	m_pix  = KGlobal::iconLoader()->loadIcon( locate("data", "kdissert/pics/nopix.png"), KIcon::NoGroup, 
			Settings::pixSize() );
	m_pixtb= KGlobal::iconLoader()->loadIcon( locate("data", "kdissert/pics/nopix.png"), KIcon::NoGroup, 
			Settings::pixSize() );

	initColor();
}

DDataItemPix::~DDataItemPix()
{

}

void DDataItemPix::printData(QTextStream& s)
{
	DDataItemBase::printData(s);
	s<<DDataItemBase::printXMLTag("legend", m_legend, 3);
	s<<DDataItemBase::printXMLTag("url", m_url, 3);
}

void DDataItemPix::loadPix(const QString & file)
{
	//kdWarning()<<"loading pix from file : "<<file<<endl;
	
	m_pix.load(file);
	updateThumb();
}

void DDataItemPix::updateThumb()
{
	QImage img = m_pix.convertToImage();
	m_pixtb.convertFromImage( 
			img.smoothScale( 
				Settings::pixSize(), 
				Settings::pixSize(), 
				QImage::ScaleMin )  );
}


