/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qstring.h>

#include "DItem.h"

DItem::DItem(int id)
{
	m_id = id;
	m_type = Unknown;
}

DItem::~DItem()
{
}

int DItem::Id() const
{
	return m_id;
}

DItem::itype DItem::Type() const
{
	return m_type;
}


// Unknown, Root, Text, Pix, Drawing, Idea, Url, File
QString TypeName(DItem::itype t)
{
	QString str;
	switch (t)
	{
		case DItem::Root:
			str = "Root";
			break;

		case DItem::Text:
			str = "Text";
			break;

		case DItem::Pix:
			str = "Pix";
			break;

		case DItem::Drawing:
			str = "Drawing";
			break;

		case DItem::Idea:
			str = "Idea";
			break;

		case DItem::Url:
			str = "Url";
			break;

		case DItem::File:
			str = "File";
			break;

		default:
			str = "Unknown";
			break;
	}
	return str;
}

DItem::itype TypeFromName(const QString & str)
{
	if ( str == "Root")
		return DItem::Root;
	
	if ( str == "Text")
		return DItem::Text;
	
	if ( str == "Pix")
		return DItem::Pix;
	
	if ( str == "Drawing")
		return DItem::Drawing;
	
	if ( str == "Idea")
		return DItem::Idea;
	
	if ( str == "Url")
		return DItem::Url;
	
	if ( str == "File")
		return DItem::File;

	return DItem::Unknown;
}








