/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _DISSERTPARSER_H
#define _DISSERTPARSER_H

#include <qxml.h>

class QString;
class QStringList;
class DItem;
class DDataControl;
class DDataItemBase;
class DissertParser : public QXmlDefaultHandler
{
	public:
		DissertParser(DDataControl*d);
		
		bool startDocument();
		bool startElement( const QString&, const QString&, const QString&, const QXmlAttributes& );
		bool endElement( const QString&, const QString&, const QString& );
		
		bool characters( const QString& s);

	private:

		bool m_inItem;
		
		DItem::itype m_type;
		int m_id;
		
		QString m_str;
		QString m_tmpstr;

		DDataControl* m_datacontrol;
};

#endif // _DISSERTPARSER_H

