/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qstring.h>
#include <kdebug.h>

#include <kstandarddirs.h>
#include <karchive.h>
#include <ktar.h>
#include <klocale.h>

#include "../gui/settings.h"
#include "DGenerator.h"

DGenerator::DGenerator() : QObject()
{
}

DGenerator::~DGenerator()
{

}

QString DGenerator::fullName()
{
	return "hum hum";
}

QString DGenerator::group()
{
	return "nogroup";
}

QString DGenerator::description()
{
	return "invalid template here";
}

QString DGenerator::quickstart()
{
        return i18n("no help available");
}

void DGenerator::generate(const QString &, DDataControl*)
{
	// base class, do nothing
}

bool DGenerator::copyfiles(const QString & destdir)
{
        KTar arch(locate("data", QString("kdissert/templatedata/")+fullName()+".tar.gz"));
        if (! arch.open(IO_ReadOnly) )
        {
		kdWarning()<<"BUG - missing template data :"<<endl;
		kdWarning()<<locate("data", QString("kdissert/templatedata/")+fullName()+".tar.gz")<<endl;
                return false;
        }

        const KArchiveDirectory *archiveDir = arch.directory();
        QStringList lst = archiveDir->entries();

        const KArchiveEntry* entry = NULL;
        for (unsigned int i=0; i<lst.count(); i++)
        {
                entry = archiveDir->entry(lst[i]);
                if (entry->isFile())
                {
                        KArchiveFile* file = (KArchiveFile*) entry;
                        file->copyTo(destdir);
                }
        }

        return true;
}

bool DGenerator::encodeUTF8()
{
	// i know .. but it's more simple than including 
	// settings.h in the templates in the subdires
	return Settings::templatesUTF8();
}

QString DGenerator::protectTex(const QString & str)
{
        QString ret = str;

	ret.replace( "$", "\\$");
	ret.replace( "\\", "$\\backslash$");

        ret.replace( "&", "\\&");
	ret.replace( "_", "\\_");
	
	ret.replace( "%", "\\%");
	
        ret.replace( "<", "$<$");
        ret.replace( ">", "$>$");


        ret.replace( "{", "$\\lbrace$" );
        ret.replace( "}", "$\\rbrace$");

	ret.replace( "[", "$[$" );
	ret.replace( "]", "$]$" );

        return ret;
}


///// TODO : i can't make this work :
//#include "DGenerator.moc"
///// anyone ?
//



