/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KDISSERTVIEW_H
#define _KDISSERTVIEW_H

#include <qwidget.h>

#include "kdissertview_base.h"

class DDataControl;
class QPainter;
class KURL;
class DCanvasView;
class DTreeListView;
/**
 * This is the main view class for kdissert.
 *
 * @short Main view
 * @author ita <tnagy256@yahoo.fr>
 * @version 0.2.1
 */
class kdissertView : public kdissertview_base
{
    Q_OBJECT
public:
    kdissertView(QWidget *parent);
    virtual ~kdissertView();

    bool saveToFile(const KURL&);
    bool loadFromFile(const KURL&);

signals:
    /**
     * Use this signal to change the content of the statusbar
     */
    void signalChangeStatusbar(const QString& text);

    /**
     * Use this signal to change the content of the caption
     */
    void signalChangeCaption(const QString& text);

public slots:
	void setLinkMode();
	void setPointMode();
	void setSortMode();
	void clearDocument();
	void generateDocument();
     	void savePic();

private slots:
    void settingsChanged();

private:
	DCanvasView* m_canvasview;
	DTreeListView* m_treelistview;
	DDataControl* m_data;
};

#endif // _KDISSERTVIEW_H

