/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qcolor.h>
#include <ktextedit.h> 

#include "ItemTextCfg-content.h"

#include "../datastruct/DDataItemText.h"
#include "ItemTextCfg.h"


ItemTextCfg::ItemTextCfg(DDataItemBase* text, QWidget* parent, const char *name ) :
KDialogBase( parent, name, true, "", KDialogBase::Ok | KDialogBase::Cancel, KDialogBase::Ok, false )
{
	m_textdata = (DDataItemText*) text;
	init();
}

ItemTextCfg::~ItemTextCfg()
{

}


void ItemTextCfg::init()
{
        m_content = new ItemTextCfg_content(this);
	setMainWidget(m_content);

	m_content->textedit->setText( m_textdata->m_text );
}

void ItemTextCfg::slotOk()
{
	m_textdata->m_text = m_content->textedit->text();
	accept();
}

#include "ItemTextCfg.moc"

