/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KDISSPDFBOOK_H
#define _KDISSPDFBOOK_H

#include <klibloader.h>
#include <qstringlist.h>
#include <qobject.h>
#include <generator/DGenerator.h>

class kdisspdflatexbookFactory : KLibFactory { Q_OBJECT public: QObject *createObject(QObject *, const char *, const char *, const QStringList & = QStringList()); };

class DDataItemRoot;
class kdisspdflatexbook : public DGenerator
{
	public:
		kdisspdflatexbook();
		~kdisspdflatexbook();

		QString fullName();
		QString group();
		QString description();
		QString quickstart();

		
		void generate(const QString &, DDataControl*);
		
	private:
		void writeMaindoc(DDataItemRoot*, const QString &);
		void writeItem(DDataItemBase* item, QTextStream & s, int level);
		
		DDataItemRoot* findRoot(DDataControl*);

		DDataControl* m_data;
};

#endif // _KDISSPDFBOOK_H
