/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qcolor.h>
#include <qevent.h>

#include <kdebug.h>
#include <klocale.h>

#include "../datastruct/DDataItemText.h"
#include "DTreeListItemBase.h"

DTreeListItemBase::DTreeListItemBase(KListView *parent, int id)
: KListViewItem(parent),  DGuiItem(parent, id)
{
	setOpen(true);
	KListViewItem::setText(0, i18n("This should not appear"));
	setDragEnabled(true);
	setDropEnabled(true);
}

DTreeListItemBase::~DTreeListItemBase()
{
}

/*
void DTreeListItemBase::dropped( QDropEvent * e )
{
	kdWarning()<<"DTreeListItemBase::dropped"<<endl;
	e->accept();
}

bool DTreeListItemBase::acceptDrop( const QMimeSource * ) const
{
	return true;
}
*/

void DTreeListItemBase::update()
{

}

int DTreeListItemBase::compare(QListViewItem* i, int, bool) const
{
	DTreeListItemBase *item = (DTreeListItemBase*) i;
	if (!item)
		return 1;
	if (item->num() == num())
		return 0;
	if (item->num() < num())
		return 1;
	return -1;
}

int DTreeListItemBase::num() const
{
	int parent = data()->Parent();
	//DDataItemBase * parentitem = (DDataItemBase *) (data(parent)); 
		
	if (data(parent))
		return data(parent)->childIdx(Id());
	else
		return -1;
}






