/***************************************************************************
 *   Copyright (C) 2004 by Thomas Nagy                                     *
 *   tnagy256@yahoo.fr                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qcolor.h>

#include <kdebug.h>
#include <klocale.h>

#include "../datastruct/DDataItemRoot.h"
#include "DTreeListItemRoot.h"

DTreeListItemRoot::DTreeListItemRoot(KListView *parent, int id)
: DTreeListItemBase(parent, id)
{
	m_type = DItem::Root;
	update();

	// this is the root - do not accept to be dropped somewhere
	setDragEnabled(false);
	setDropEnabled(true);
}

DTreeListItemRoot::~DTreeListItemRoot()
{
}

void DTreeListItemRoot::update()
{
        if (!data())
        {
                kdWarning()<<"Bug: in DTreeListItemRoot::update"<<endl;
                return;
        }
        if (data()->Type() != DItem::Root)
        {
                kdWarning()<<"Bug: DTreeListItemRoot has no root data !!"<<endl;
                return;
        }

        KListViewItem::setText(0, ((DDataItemRoot*) data())->m_title);
}


